import { HttpServer } from './services/http-server';
import { DataService } from './services/data-service';
import { WebSocketService } from './services/websocket-service';
import { Model, QueryBuilder, EventListener } from './services/interfaces';
import { FastifyServerOptions, FastifyPluginOptions } from 'fastify';
import { ServerOptions as SocketIOServerOptions } from 'socket.io';
export declare class Server {
    private dataService;
    private httpServer;
    private webSocketService;
    run(host?: string, port?: number, socketHost?: string, socketPort?: number, fastifyOptions?: {
        fastify?: FastifyServerOptions;
        jwt?: FastifyPluginOptions;
        cors?: FastifyPluginOptions;
        fileUpload?: FastifyPluginOptions;
        swagger?: FastifyPluginOptions;
    }, socketOptions?: SocketIOServerOptions): Promise<void>;
    listenNetwork(): void;
    getDataService(): DataService;
    getHttpServer(): HttpServer;
    getWebSocketService(): WebSocketService;
    registerQueryBuilder(queryBuilders: QueryBuilder[]): void;
    registerModel(models: Model[]): void;
    regsiterEventListener(listener: EventListener): void;
    stop(): Promise<void>;
}
