/// <reference types="node" />
import { FastifyInstance, FastifyPluginOptions, FastifyServerOptions } from 'fastify';
import 'fastify-cors';
import 'fastify-jwt';
import 'fastify-file-upload';
import { DataService } from './data-service';
import { Model } from './interfaces';
import { SignOptions, VerifyOptions } from 'jsonwebtoken';
export declare class HttpServer {
    private dataService;
    private host;
    private port;
    private options;
    private fastifyServer;
    constructor(dataService: DataService, host: string, port: number, options?: {
        fastify?: FastifyServerOptions;
        jwt?: FastifyPluginOptions;
        cors?: FastifyPluginOptions;
        fileUpload?: FastifyPluginOptions;
        swagger?: FastifyPluginOptions;
    });
    start(): void;
    listenNetwork(): void;
    stop(): Promise<void>;
    sign(payload: object, options?: SignOptions): string;
    verify(token: string, options?: VerifyOptions): object;
    registerModelRoutes(models: Model[]): void;
    getFastifyServer(): FastifyInstance<import("http").Server, import("http").IncomingMessage, import("http").ServerResponse, import("fastify").FastifyLoggerInstance>;
}
